#include "callerid.h"
CallerID::CallerID(void) : x(0), n(0), hSerial(0), myBytesRead(0), bBaudRate(0), bParity(0), bBits(0), bInit(0)  {

	this->ClearBuffer();
	dcbSerialParams.DCBlength=sizeof(dcbSerialParams);
	dcbSerialParams.ByteSize=8; // default for caller id change if you think you need a different bit size

}

CallerID::~CallerID(void) {

}
void CallerID::KillCOM(void) {
	CloseHandle(hSerial);
}
int CallerID::InitCOM(char * com) {
	
	// check if all settings have been set!
	if (!bBaudRate) { return 0; }
	else if (!bBits) { return 0; }
	else if (!bParity) { return 0; }


	hSerial = NULL;
	hSerial = CreateFileA(com, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0); // ascii support for filenames only now

	if (!hSerial) { return 60; }
	else if (hSerial == INVALID_HANDLE_VALUE) { return 0; }
	else {
		SetCommState(hSerial, &dcbSerialParams);
		timeouts.ReadIntervalTimeout=100;
		timeouts.ReadTotalTimeoutConstant=100;
		timeouts.ReadTotalTimeoutMultiplier=20;
		SetCommTimeouts(hSerial, &timeouts);

		/* THIS HERE ARE ALL POSSIBLE MODEM CODES TO TURN CID ON
		AT#CID=1
		AT#CLS=8#CID=1
		AT#CID=2
		AT%CCID=1
		AT%CCID=2
		AT+VCID=1
		AT#CC1
		AT*ID1
*/
		if (!WriteFile( hSerial, "ATZ\r", strlen("ATZ\r"), &myBytesRead, 0 )) { return 0; }

		// should work on most
		 if (!WriteFile( hSerial, "AT#CID=1\r", strlen("AT#CID=1\r"), &myBytesRead, 0 )) { return 0; }

		 // If the DLL does not work for you modify it and try to use the correct command to initiate caller id

		 /*
		 if (!WriteFile( hSerial, "AT#CLS=8#CID=1\r", strlen("AT#CLS=8#CID=1\r"), &myBytesRead, 0 )) { return 0; }
		 if (!WriteFile( hSerial, "AT#CID=2\r", strlen("AT#CID=2\r"), &myBytesRead, 0 )) { return 0; }
		 if (!WriteFile( hSerial, "AT%CCID=1\r", strlen("AT%CCID=1\r"), &myBytesRead, 0 )) { return 0; }
		 if (!WriteFile( hSerial, "AT%CCID=2\r", strlen("AT%CCID=2\r"), &myBytesRead, 0 )) { return 0; }
		 if (!WriteFile( hSerial, "AT+VCID=1\r", strlen("AT+VCID=1\r"), &myBytesRead, 0 )) { return 0; }
		 if (!WriteFile( hSerial, "AT#CC1\r", strlen("AT#CC1\r"), &myBytesRead, 0 )) { return 0; }
		 if (!WriteFile( hSerial, "AT*ID1\r", strlen("AT*ID1\r"), &myBytesRead, 0 )) { return 0; }
		 */
	}
	this->ClearBuffer();
	return 1;

}

char * CallerID::ReadCOM(void) {

			ReadFile(hSerial, szBuff, 400, &myBytesRead, NULL);
			if (!bInit) { bInit = 1; this->ClearBuffer(); return "0"; }
			return szBuff;
}
void CallerID::ClearBuffer(void) {
	   strcpy(szBuff, "0");
		//string_gettoken(data,0,' ');;
}
int CallerID::SetBaudRate(int iBaudRate) {


	switch (iBaudRate) {

			case 110:
				dcbSerialParams.BaudRate=CBR_110; break;

			case 300:
				dcbSerialParams.BaudRate=CBR_300; break;

			case 600:
				dcbSerialParams.BaudRate=CBR_600; break;

			case 1200:
				dcbSerialParams.BaudRate=CBR_1200; break;

			case 2400:
				dcbSerialParams.BaudRate=CBR_2400; break;

			case 4800:
				dcbSerialParams.BaudRate=CBR_4800; break;

			case 9600:
				dcbSerialParams.BaudRate=CBR_9600; break;

			case 14400:
				dcbSerialParams.BaudRate=CBR_14400; break;

			case 19200:
				dcbSerialParams.BaudRate=CBR_19200; break;

			case 38400:
				dcbSerialParams.BaudRate=CBR_38400; break;

			case 57600:
				dcbSerialParams.BaudRate=CBR_57600; break;

			case 115200:
				dcbSerialParams.BaudRate=CBR_115200; break;

			case 128000:
				dcbSerialParams.BaudRate=CBR_128000; break;

			case 256000:
				dcbSerialParams.BaudRate=CBR_256000; break;

			default:
				return 0; // error baud rate not supported.
	}
    bBaudRate = 1;
	return 1; // success

}

int CallerID::SetParity(int iParity) {

	switch (iParity) {
	
		case 0:
			dcbSerialParams.Parity=NOPARITY; break;

		case 1:
			dcbSerialParams.Parity=ODDPARITY; break;

		case 2:
			dcbSerialParams.Parity=EVENPARITY; break;

		case 3:
			dcbSerialParams.Parity=MARKPARITY; break;

		case 4:
			dcbSerialParams.Parity=SPACEPARITY; break;
			
		default:
			return 0; // not supported value
	}

	bParity = 1;
	return 1; // success
}


int CallerID::SetStopBits(int iBits) {

	switch (iBits) {
		case 0:
			dcbSerialParams.StopBits=ONESTOPBIT; break;

		case 1:
			dcbSerialParams.StopBits=ONE5STOPBITS; break;

		case 2:
			dcbSerialParams.StopBits=TWOSTOPBITS; break;

		default:
			return 0; // error
	}

	bBits = 1;
	return 1; // success
}

