/****************************************************************************
 ****************************************************************************
 **
 **  Caller ID DLL for mIRC
 **  - Receives Incoming Data from a COM Port and signals mIRC.
 **  - TAPI Compliant modem is NOT Required
 **
 **  Author: Haso Keric <hasokeric@comcast.net>
 **
 ****************************************************************************
 ****************************************************************************/

#define _WIN32_WINNT 0x0600 // ENABLES VISTA STUFF
#define func(x) int WINAPI x(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
#include <windows.h>
#include <cstdio>
#include <process.h>
#include "callerid.h"



CallerID * callerid = NULL;

HANDLE mFile;
HWND mWnd;
LPSTR mData;
    int x = 0; // loop determening the unlimited incoming call checker
HANDLE hThread;
unsigned threadID;


typedef struct 
{
    DWORD  mVersion;
    HWND   mHwnd;
    BOOL   mKeep;
} LOADINFO; /* Store LOADINFO data from mIRC */

/* LoadDll -> Called when mIRC Loads a DLL */
void __stdcall LoadDll(LOADINFO *mIRC)
{
	/* File Map DLL <-> mIRC */
    mWnd = mIRC->mHwnd;
    mFile = CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,4096, TEXT("mIRC") );
    mData = (LPSTR)MapViewOfFile(mFile,FILE_MAP_ALL_ACCESS,0,0,0); 
}

int __stdcall UnloadDll(int timeout)
{
    if (!timeout)
    {
		x = 1;
		WaitForSingleObject(hThread, INFINITE);
        callerid->KillCOM();
		if (callerid) { delete callerid; }
        UnmapViewOfFile(mData);
        CloseHandle(mFile);
    }
    return 0;
}


unsigned __stdcall SecondThreadFunc( void* pArguments )
{

	while (!x) {

		if (strcmp(callerid->ReadCOM(), "0")) {
				wsprintfA(mData,"/.signal CALLERID %s", callerid->ReadCOM());
 				SendMessage(mWnd, WM_USER+200, NULL, NULL);
				callerid->ClearBuffer();
		}
	}
	_endthreadex( 0 );
	return 0;
}


func(about) {
	sprintf(data, "CID v1.0 - hasokeric@comcast.net" );
	return 3;
}

func(mCreateCID) {
	if (callerid == NULL) {
		callerid = new CallerID;
		if (callerid)
			sprintf(data,"S_OK");

		else
			sprintf(data,"NO_MEMORY");
	}

	else { sprintf(data,"ERR_EXISTS"); } // Created Object Exists
	return 3;
}
func(mDeleteCID) {
	if (callerid == NULL) { sprintf(data,"ERR_CREATE_FIRST"); }

	else {
		sprintf(data,"NULL");
		delete callerid;
		callerid = NULL;
		sprintf(data,"S_OK");
	}

	return 3;
}

func(mSetBaudRate) {
	if (callerid == NULL) { sprintf(data,"ERR_CREATE_FIRST"); }
	else { 
		if (data) { sprintf(data,"%i", callerid->SetBaudRate(atoi(data)) ); }
		else { sprintf(data,"ERR_MISSING_ARGS"); }
	}
	return 3;
}

func(mSetParity) {
	if (callerid == NULL) { sprintf(data,"ERR_CREATE_FIRST"); }
	else { 
		if (data) { sprintf(data,"%i", callerid->SetParity(atoi(data)) ); }
		else { sprintf(data,"ERR_MISSING_ARGS"); }
	}
	return 3;
}

func(mSetStopBits) {
	if (callerid == NULL) { sprintf(data,"ERR_CREATE_FIRST"); }
	else { 
		if (data) { sprintf(data,"%i", callerid->SetStopBits(atoi(data)) ); }
		else { sprintf(data,"ERR_MISSING_ARGS"); }
	}
	return 3;
}

func(mInitCOM) {
	if (callerid == NULL) { sprintf(data,"ERR_CREATE_FIRST"); }
	else { 
		if (data) { 
			sprintf(data,"%i", callerid->InitCOM(data));
		}
		else { sprintf(data,"ERR_MISSING_ARGS"); }
	}
	return 3;
}

func(mReadCOM) {
	if (callerid == NULL) { sprintf(data,"ERR_CREATE_FIRST"); }
	else { 
		if (data) { 
					callerid->ClearBuffer();
					hThread = (HANDLE)_beginthreadex( NULL, 0, &SecondThreadFunc, NULL, 0, &threadID );
					sprintf(data,"%i", 1);
		}
		else { sprintf(data,"ERR_MISSING_ARGS"); }
	}
	return 3;
}